# -*- coding: utf-8 -*-
# Copyright (C) 2012-2013 Team tiramisu (see AUTHORS for all contributors)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# The original `Config` design model is unproudly borrowed from
# the rough pypy's guys: http://codespeak.net/svn/pypy/dist/pypy/config/
# the whole pypy projet is under MIT licence
# ____________________________________________________________

#ValueError if function's parameter not correct
#           or if not logical
#           or if validation failled
#           or multi must be a list
#           or error in autolib
#TypeError if parameter has no good type
#AttributeError if no option or optiondescription in optiondescription (also when specified a path)


#____________option___________
class PropertiesOptionError(AttributeError):
    "try to access to opt with not allowed property"
    def __init__(self, msg, proptype):
        self.proptype = proptype
        super(PropertiesOptionError, self).__init__(msg)


#____________config___________
class ConfigError(StandardError):
    """try to change owner for an option without value
    or if _cfgimpl_descr is None
    or if error in calculation"""
    pass


class ConflictError(StandardError):
    "duplicate config"
    pass


#____________other___________
class RequirementRecursionError(StandardError):
    "recursive error"
    pass


class SlaveError(StandardError):
    "problem with slave's length"
    pass
